/*
*  Rubrica
*  file: prefer_int.c
*
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 * NON MODIFICARE QUESTO FILE - generato automaticamente da Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "prefer.h"
#include "prefer_cb.h"
#include "prefer_int.h"
/* #include "support.h" */

GtkWidget *propertybox;

GSList *opt_file_group = NULL;
GSList *opt_ordine_group = NULL;
GSList *opt_ord_tipo_group = NULL;
GSList *opt_back_group = NULL;
GSList *opt_exit_group = NULL;

GtkWidget *radio_show_file;
GtkWidget *radio_show_path;
GtkWidget *radio_alfa;
GtkWidget *radio_data;
GtkWidget *radio_increase;
GtkWidget *radio_decrease;
GtkWidget *radio_backup_never;
GtkWidget *radio_backup_always;
GtkWidget *radio_confirm_no;
GtkWidget *radio_confirm_yes;

GtkWidget *check_default;

GtkWidget *fileentry1;
GtkWidget *combo_entry1;

GtkWidget*
create_propertybox (RubricaPreferences *p)
{
  GtkWidget *notebook1;
  GtkWidget *frame1;
  GtkWidget *frame2;
  GtkWidget *frame3;
  GtkWidget *frame4;
  GtkWidget *frame5;

  GtkWidget *vbox1;
  GtkWidget *vbox2;

  GtkWidget *hbox1;
  GtkWidget *hbox2;

  GtkWidget *table1;
  GtkWidget *table2;

  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label5;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *label8;

  propertybox = gnome_property_box_new ();
  gtk_widget_set_name (propertybox, "propertybox");
  gtk_object_set_data (GTK_OBJECT (propertybox), "propertybox", propertybox);
  gtk_container_set_border_width (GTK_CONTAINER (propertybox), 5);
  gtk_window_set_title (GTK_WINDOW (propertybox), _("Preferences"));
  gtk_window_set_modal (GTK_WINDOW (propertybox), TRUE);
  gtk_window_set_policy (GTK_WINDOW (propertybox), FALSE, FALSE, FALSE);

  notebook1 = GNOME_PROPERTY_BOX (propertybox)->notebook;
  gtk_widget_set_name (notebook1, "notebook1");
  gtk_object_set_data (GTK_OBJECT (propertybox), "notebook1", notebook1);
  gtk_widget_show (notebook1);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_container_add (GTK_CONTAINER (notebook1), frame1);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 5);

  vbox1 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (frame1), vbox1);

  frame2 = gtk_frame_new (_(" File "));
  gtk_widget_set_name (frame2, "frame2");
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox1), frame2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 5);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (frame2), hbox1);

  /*      Radio Button: show filename
   */
  radio_show_file = gtk_radio_button_new_with_label (opt_file_group, _("show filename"));
  opt_file_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_show_file));
  gtk_widget_set_name (radio_show_file, "radio_show_file");
  gtk_widget_ref (radio_show_file);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "radio_show_file", radio_show_file,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_show_file);
  gtk_box_pack_start (GTK_BOX (hbox1), radio_show_file, TRUE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radio_show_file), p->show_file);

  /*    Radio Button: show path
   */
  radio_show_path = gtk_radio_button_new_with_label (opt_file_group, _("show path"));
  opt_file_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_show_path));
  gtk_widget_set_name (radio_show_path, "radio_show_path");
  gtk_widget_ref (radio_show_path);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "radio_show_path", radio_show_path,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_show_path);
  gtk_box_pack_start (GTK_BOX (hbox1), radio_show_path, TRUE, FALSE, 0);

  frame5 = gtk_frame_new (_(" Default address book "));
  gtk_widget_set_name (frame5, "frame5");
  gtk_widget_ref (frame5);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "frame5", frame5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame5);
  gtk_box_pack_start (GTK_BOX (vbox1), frame5, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame5), 5);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox2, "hbox2");
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER (frame5), hbox2);

  /*    Check button: load default addressbook
  */
  check_default = gtk_check_button_new_with_label (_("load default addressbook when start"));
  gtk_widget_set_name (check_default, "check_default");
  gtk_widget_ref (check_default);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "check_default", check_default,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (check_default), p->default_addressbook);
  gtk_widget_show (check_default);
  gtk_box_pack_start (GTK_BOX (hbox2), check_default, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (check_default), 5);

  /*    Fileentry
   */
  fileentry1 = gnome_file_entry_new (NULL, NULL);
  gtk_widget_set_name (fileentry1, "fileentry1");
  gtk_widget_ref (fileentry1);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "fileentry1", fileentry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fileentry1);
  gtk_box_pack_start (GTK_BOX (hbox2), fileentry1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fileentry1), 5);

  /*    Combo box: default file name:
   */
  combo_entry1 = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (fileentry1));
  gtk_widget_set_name (combo_entry1, "combo_entry1");
  gtk_widget_ref (combo_entry1);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "combo_entry1", combo_entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_entry_set_text (GTK_ENTRY (combo_entry1), p->default_filename);
  gtk_widget_show (combo_entry1);

  frame3 = gtk_frame_new (_(" Ordering "));
  gtk_widget_set_name (frame3, "frame3");
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox1), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 5);

  vbox2 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox2, "vbox2");
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (frame3), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 5);

  table1 = gtk_table_new (2, 3, TRUE);
  gtk_widget_set_name (table1, "table1");
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox2), table1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 5);

  label5 = gtk_label_new (_("Show cards:  "));
  gtk_widget_set_name (label5, "label5");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_table_attach (GTK_TABLE (table1), label5, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label5), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label5), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label5), 2.66358e-07, 0.5);

  /*    Radio button: alphabetic order
   */
  radio_alfa = gtk_radio_button_new_with_label (opt_ordine_group, _("in alphabetic order"));
  opt_ordine_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_alfa));
  gtk_widget_set_name (radio_alfa, "radio_alfa");
  gtk_widget_ref (radio_alfa);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "radio_alfa", radio_alfa,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_alfa);
  gtk_table_attach (GTK_TABLE (table1), radio_alfa, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radio_alfa), p->alpha);

  /*    Radio button: date order
  */
  radio_data = gtk_radio_button_new_with_label (opt_ordine_group, _("by creation date"));
  opt_ordine_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_data));
  gtk_widget_set_name (radio_data, "radio_data");
  gtk_widget_ref (radio_data);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "radio_data", radio_data,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_data);
  gtk_table_attach (GTK_TABLE (table1), radio_data, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  label6 = gtk_label_new (_("Ordering is:  "));
  gtk_widget_set_name (label6, "label6");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_table_attach (GTK_TABLE (table1), label6, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label6), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label6), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label6), 0, 0.5);

  /*      Radio order: increasing
   */
  radio_increase = gtk_radio_button_new_with_label (opt_ord_tipo_group, _("increasing"));
  opt_ord_tipo_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_increase));
  gtk_widget_set_name (radio_increase, "radio_increase");
  gtk_widget_ref (radio_increase);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "radio_increase", radio_increase,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_increase);
  gtk_table_attach (GTK_TABLE (table1), radio_increase, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radio_increase), p->increasing);

  /*      Radio order: decreasing
   */  
  radio_decrease = gtk_radio_button_new_with_label (opt_ord_tipo_group, _("decreasing"));
  opt_ord_tipo_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_decrease));
  gtk_widget_set_name (radio_decrease, "radio_decrease");
  gtk_widget_ref (radio_decrease);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "radio_decrease", radio_decrease,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_decrease);
  gtk_table_attach (GTK_TABLE (table1), radio_decrease, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  label1 = gtk_label_new (_("Info"));
  gtk_widget_set_name (label1, "label1");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label1);

  frame4 = gtk_frame_new (_(" Preferences "));
  gtk_widget_set_name (frame4, "frame4");
  gtk_widget_ref (frame4);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "frame4", frame4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame4);
  gtk_container_add (GTK_CONTAINER (notebook1), frame4);
  gtk_container_set_border_width (GTK_CONTAINER (frame4), 5);

  table2 = gtk_table_new (3, 3, TRUE);
  gtk_widget_set_name (table2, "table2");
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (frame4), table2);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table2), 1);
  gtk_table_set_col_spacings (GTK_TABLE (table2), 5);

  /*      Radio backup: never
   */  
  radio_backup_never = gtk_radio_button_new_with_label (opt_back_group, _("never"));
  opt_back_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_backup_never));
  gtk_widget_set_name (radio_backup_never, "radio_backup_never");
  gtk_widget_ref (radio_backup_never);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "radio_backup_never", radio_backup_never,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_backup_never);
  gtk_table_attach (GTK_TABLE (table2), radio_backup_never, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radio_backup_never), p->backup);

  /*      Radio backup: always
   */    
  radio_backup_always = gtk_radio_button_new_with_label (opt_back_group, _("always"));
  opt_back_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_backup_always));
  gtk_widget_set_name (radio_backup_always, "radio_backup_always");
  gtk_widget_ref (radio_backup_always);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "radio_backup_always", radio_backup_always,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_backup_always);
  gtk_table_attach (GTK_TABLE (table2), radio_backup_always, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*      Radio confirm exit: no
   */  
  radio_confirm_no = gtk_radio_button_new_with_label (opt_exit_group, _("never"));
  opt_exit_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_confirm_no));
  gtk_widget_set_name (radio_confirm_no, "radio_confirm_no");
  gtk_widget_ref (radio_confirm_no);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "radio_confirm_no", radio_confirm_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_confirm_no);
  gtk_table_attach (GTK_TABLE (table2), radio_confirm_no, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*      Radio confirm exit: yes
   */  
  radio_confirm_yes = gtk_radio_button_new_with_label (opt_exit_group, _("always"));
  opt_exit_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_confirm_yes));
  gtk_widget_set_name (radio_confirm_yes, "radio_confirm_yes");
  gtk_widget_ref (radio_confirm_yes);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "radio_confirm_yes", radio_confirm_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radio_confirm_yes), p->confirm);
  gtk_widget_show (radio_confirm_yes);
  gtk_table_attach (GTK_TABLE (table2), radio_confirm_yes, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label8 = gtk_label_new (_("Confirm exit from rubrica: "));
  gtk_widget_set_name (label8, "label8");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_table_attach (GTK_TABLE (table2), label8, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label8), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label8), 0, 0.5);

  label7 = gtk_label_new (_("Make backup: "));
  gtk_widget_set_name (label7, "label7");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_table_attach (GTK_TABLE (table2), label7, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label7), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label7), 0, 0.5);

  label2 = gtk_label_new (_("Preferences"));
  gtk_widget_set_name (label2, "label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (propertybox), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label2);

  gtk_signal_connect (GTK_OBJECT (propertybox), "apply",
                      GTK_SIGNAL_FUNC (on_propertybox_apply),
                      NULL);


  gtk_signal_connect (GTK_OBJECT (radio_show_file), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_show_file_toggled),
                      (gpointer) propertybox);
  gtk_signal_connect (GTK_OBJECT (radio_show_path), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_show_path_toggled),
                      (gpointer) propertybox);
  gtk_signal_connect (GTK_OBJECT (check_default), "toggled",
                      GTK_SIGNAL_FUNC (on_check_default_toggled),
                     (gpointer) propertybox);
  gtk_signal_connect (GTK_OBJECT (radio_alfa), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_alfa_toggled),
                     (gpointer) propertybox);
  gtk_signal_connect (GTK_OBJECT (radio_data), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_data_toggled),
                      (gpointer) propertybox);
  gtk_signal_connect (GTK_OBJECT (radio_increase), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_increase_toggled),
                     (gpointer) propertybox);
  gtk_signal_connect (GTK_OBJECT (radio_decrease), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_decrease_toggled),
                     (gpointer) propertybox);
  gtk_signal_connect (GTK_OBJECT (radio_backup_never), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_backup_never_toggled),
                      (gpointer) propertybox);
  gtk_signal_connect (GTK_OBJECT (radio_backup_always), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_backup_always_toggled),
                      (gpointer) propertybox);
  gtk_signal_connect (GTK_OBJECT (radio_confirm_no), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_confirm_no_toggled),
                      (gpointer) propertybox);
  gtk_signal_connect (GTK_OBJECT (radio_confirm_yes), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_confirm_yes_toggled),
                      (gpointer) propertybox);
  return propertybox;
}

